<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//db access function
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

//aws image store
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning . "vendor/autoload.php";

require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';
require_once $base_path_to_learning_resources . '/lib/cron_jobs/firebase_notification/notification_history_function.php';

$postdata = json_decode(file_get_contents("php://input"), true);
// print_r($postdata);die();
checkIfNoPhpContentsReceive();

if (

    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type'])  or !isset($postdata['jwt_token']) or  !isset($postdata['jwt_token'])
) {
    errorreturn("All * fields are required.");
}
validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;

$institution_id = $jwt_validate->data->institution_id;
$branch_id = $jwt_validate->data->branch_id;
$class_id = $jwt_validate->data->class;
$section_id = $jwt_validate->data->section;

$specific_db_name = validateStudentAcess($conn_rjllearning, $role, $workspace_id, ["student"], null, null, $userid);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}
validateStudentClassSection($conn_rjllearning_specific, $userid, $institution_id, $branch_id, $class_id, $section_id);


 if ($postdata['function_type'] == "fetch_student_notification") {

    // Required field
 

    $user_id = $userid;
    $search_string = isset($postdata['search_string']) ? trim($postdata['search_string']) : null;
    $from_date = isset($postdata['from_date']) ? trim($postdata['from_date']) : null;
    $to_date = isset($postdata['to_date']) ? trim($postdata['to_date']) : null;

    if ($from_date && $to_date && $from_date > $to_date) {
        errorreturn('Invalid Date Range');
    }

    $limit = isset($postdata['limit']) ? $postdata['limit'] : 10;
    $page = (isset($postdata['page']) && is_numeric($postdata['page'])) ? (int)$postdata['page'] : 1;

    // $check_academic_confirmation = CheckAcademicSession($conn_rjllearning_specific, $institution_id);
    // if ($check_academic_confirmation !== true) {
    //     errorreturn("Access denied. Academic session not active.");
    // }

    // Filters for fetchNotifications
    $filters = [
        'user_id' => $user_id,
        'search_string' => $search_string,
        'from_date' => $from_date,
        'to_date' => $to_date,
        'limit' => $limit,
        'offset' => ($limit !== 'all') ? (($page - 1) * $limit) : null,
    ];

    $success['data'] = fetchNotifications($conn_rjllearning, $userid);
    successreturn($success);
}
